np_old/web/router.ex
defmodule NanoPlanner.Router do
  use NanoPlanner.Web, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  scope "/", NanoPlanner do
    pipe_through :browser

    get "/", TopController, :index
    get "/plan_items", PlanItemsController, :index
    get "/plan_items/:id", PlanItemsController, :show
  end
end

np_old/lib/nano_planner/endpoint.ex
defmodule NanoPlanner.Endpoint do
  use Phoenix.Endpoint, otp_app: :nano_planner

  socket "/socket", NanoPlanner.UserSocket

  # Serve at "/" the static files from "priv/static" directory.
  #
  # You should set gzip to true if you are running phoenix.digest
  # when deploying your static files in production.
  plug Plug.Static,
    at: "/", from: :nano_planner, gzip: false,
    only: ~w(css fonts images js favicon.ico robots.txt)

  # Code reloading can be explicitly enabled under the
  # :code_reloader configuration of your endpoint.
  if code_reloading? do
    socket "/phoenix/live_reload/socket", Phoenix.LiveReloader.Socket
    plug Phoenix.LiveReloader
    plug Phoenix.CodeReloader
  end

  plug Plug.RequestId
  plug Plug.Logger

  plug Plug.Parsers,
    parsers: [:urlencoded, :multipart, :json],
    pass: ["*/*"],
    json_decoder: Poison

  plug Plug.MethodOverride
  plug Plug.Head

  # The session will be stored in the cookie and signed,
  # this means its contents can be read but not tampered with.
  # Set :encryption_salt if you would also like to encrypt it.
  plug Plug.Session,
    store: :cookie,
    key: "_nano_planner_key",
    signing_salt: "clw5PuHS"

  plug NanoPlanner.Router
end

np_old/lib/nano_planner/repo.ex
defmodule NanoPlanner.Repo do
  use Ecto.Repo, otp_app: :nano_planner
end

np_old/web/models/plan_item.ex
defmodule NanoPlanner.PlanItem do
  use NanoPlanner.Web, :model

  schema "plan_items" do
    field :name, :string
    field :description, :string
    field :starts_at, Timex.Ecto.DateTime
    field :ends_at, Timex.Ecto.DateTime

    timestamps()
  end

  @doc """
  Builds a changeset based on the `struct` and `params`.
  """
  def changeset(struct, params \\ %{}) do
    struct
    |> cast(params, [])
    |> validate_required([])
  end

  def convert_datetime(items) when is_list(items) do
    Enum.map items, &(convert_datetime &1)
  end

  def convert_datetime(%__MODULE__{} = item) do
    alias Timex.Timezone

    time_zone = Application.get_env(:nano_planner, :default_time_zone)
    Map.merge(item, %{
      starts_at: Timezone.convert(item.starts_at, time_zone),
      ends_at: Timezone.convert(item.ends_at, time_zone)
      })
  end
end

np_old/web/controllers/plan_items_controller.ex
defmodule NanoPlanner.PlanItemsController do
  use NanoPlanner.Web, :controller
  alias NanoPlanner.PlanItem

  def index(conn, _params) do
    plan_items =
      PlanItem
      # |> Ecto.Query.order_by(asc: :starts_at)
      |> order_by(asc: :starts_at, asc: :ends_at, asc: :id)
      |> Repo.all
      |> PlanItem.convert_datetime
    render conn, "index.html", plan_items: plan_items
  end

  def show(conn, params) do
    # plan_item = PlanItem |> Repo.get! (params["id"])
    plan_item =
      PlanItem
      |> Repo.get!(params["id"])
      |> PlanItem.convert_datetime
    render conn, "show.html", plan_item: plan_item
  end
end

np_old/web/controllers/top_controller.ex
defmodule NanoPlanner.TopController do
  use NanoPlanner.Web, :controller

  def index(conn, _params) do
    render conn, "index.html"
  end
end

np_old/web/views/error_view.ex
defmodule NanoPlanner.ErrorView do
  use NanoPlanner.Web, :view

  def render("404.html", _assigns) do
    "Page not found"
  end

  def render("500.html", _assigns) do
    "Internal server error"
  end

  # In case no render clause matches or no
  # template is found, let's render it as 500
  def template_not_found(_template, assigns) do
    render "500.html", assigns
  end
end

np_old/web/views/layout_view.ex
defmodule NanoPlanner.LayoutView do
  use NanoPlanner.Web, :view
end

np_old/web/views/plan_items_view.ex
defmodule NanoPlanner.PlanItemsView do
  use NanoPlanner.Web, :view
  alias Timex.Format.DateTime.Formatters.Strftime

  def format_duration(item) do
    # [item.starts_at, "〜", item.ends_at] |> Enum.join(" ")
    [format_starts_at(item), "〜", format_ends_at(item)] |> Enum.join(" ")
  end

  defp format_starts_at(item) do
    time_zone = Application.get_env(:nano_planner, :default_time_zone)
    w = format_wday(item.starts_at)
    if item.starts_at.year == Timex.now(time_zone).year do
      Strftime.format! item.starts_at, "%-m月%-d日（#{w}） %H:%M"
    else
      Strftime.format! item.starts_at, "%Y年%-m月%-d日（#{w}） %H:%M"
    end
  end

  defp format_ends_at(item) do
    w = format_wday(item.ends_at)
    cond do
      Timex.to_date(item.ends_at) == Timex.to_date(item.starts_at) ->
        Strftime.format! item.ends_at, "%H:%M"
        item.ends_at.year == item.starts_at ->
          Strftime.format! item.ends_at, "%-m月%-d日（#{w}） %H:%M"
        true ->
          Strftime.format! item.ends_at, "%Y年%-m月%-d日（#{w}） %H:%M"
    end
  end

  def format_datetime(datetime) do
    w = format_wday(datetime)
    Strftime.format! datetime, "%Y年%-m月%-d日（#{w}） %H:%M"
  end

  defp format_wday(datetime) do
    Enum.at ~w(日 月 火 水 木 金 土),
      Timex.days_to_beginning_of_week(datetime, :sun)
  end
end

np_old/web/views/top_view.ex
defmodule NanoPlanner.TopView do
  use NanoPlanner.Web, :view
end

np_old/web/templates/layout/app.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>NanoPlanner</title>
    <%= tag :link, rel: "stylesheet",
      href: static_path(@conn, "/css/app.css") %>
    <%= tag :link, rel: "shortcut icon",
      href: static_path(@conn, "/images/nano_planner.ico") %>
    <%= tag :link, rel: "apple-touch-icon",
      href: static_path(@conn, "/images/clock256.png") %>
  </head>

  <body>
    <header>
      <h1><%= link "NanoPlanner", to: top_path(@conn, :index,[]) %></h1>
    </header>
    <main>
      <%= render @view_module, @view_template, assigns %>
    </main>
    <footer>
      &copy; 2017 Oiax Inc.
    </footer>
    <%= content_tag :script, "", src: static_path(@conn, "/js/app.js") %>
  </body>
</html>

np_old/web/templates/plan_items/index.html.eex
<div class="container-fluid plan-items">
<%= for item <- @plan_items do %>
  <div class="row">
    <div class="col-12 col-md-4">
      <span class="plan-item-name">
        <%= link item.name, to: plan_items_path(@conn, :show, item.id) %>
      </span>
    </div>
    <div class="col-12 col-md-8">
      <span class="plan-item-description">
        <%= for line <- String.split(item.description, "\n") do %>
          <%= line %><br>
        <% end %>
      </span>
    </div>
    <div class="col-12">
      <span class="plan-item-duration">
        <%= format_duration(item) %>
      </span>
    </div>
  </div>
  <% end %>
</div>

np_old/web/templates/plan_items/show.html.eex
<div class="container-fluid plan-item">
  <div class="row">
    <div class="col-12 d-md-none text-right">
      <%= link to: plan_items_path(@conn, :index) do %>
      <i class="fa fa-list fa-lg"></i>
      <% end %>
    </div>
    <div class="col-md-12 d-none d-md-block text-right">
      <%= link to: plan_items_path(@conn, :index),
        class: "btn btn-secondary btn-sm" do %>
        <i class="fa fa-list"></i>予定表へ戻る
      <% end %>
    </div>
  </div>
  <div class="row">
    <div class="col-12 col-md-4 bg-info text-white text-md-right" >件名</div>
    <div class="col-12 col-md-8">
      <%= @plan_item.name %>
    </div>
  </div>
  <div class="row">
    <div class="col-12 col-md-4 bg-info text-white text-md-right">説明</div>
    <div class="col-12 col-md-8">
      <%= for line <- String.split(@plan_item.description, "\n") do %>
        <%= line %><br>
      <% end %>
    </div>
  </div>
  <div class="row">
    <div class="col-12 col-md-4 bg-info text-white text-md-right">開始日時</div>
    <div class="col-12 col-md-8">
      <%= format_datetime @plan_item.starts_at %>
    </div>
  </div>
  <div class="row">
    <div class="col-12 col-md-4 bg-info text-white text-md-right">  終了日時</div>
    <div class="col-12 col-md-8">
      <%= format_datetime @plan_item.ends_at %>
    </div>
  </div>
</div>

np_old/web/templates/top/index.html.eex
<div class="">
  <%= link to: plan_items_path(@conn, :index) do %>
  <i class="fa fa-list"></i> 予定表
  <% end %>
</div>